#include <LiquidCrystal_I2C.h>
#include <Keypad.h>

LiquidCrystal_I2C lcd(0x27, 16, 2); // I2C address 0x27, 16 column and 2 rows

int led = 9;
int sensor = 5;
int buzzer = 7;

int state = LOW; 
int val = 0; 
bool citit = false;
int errors = 0;

const byte ROWS = 4;
const byte COLS = 3;

// Keypad
char keys[ROWS][COLS] = {
  {'1', '2', '3'},
  {'4', '5', '6'},
  {'7', '8', '9'},
  {'*', '0', '#'}
};

byte rowPins[ROWS] = {13, 12, 11, 10};
byte colPins[COLS] = {4, 3, 2};

String password = "1111";
String input_password;

Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );

void setup()
{
  lcd.init();
  lcd.backlight();
  lcd.noBlink();

  lcd.setCursor(3, 0);
  lcd.print("Sunteti in");
  lcd.setCursor(3, 1);
  lcd.print("siguranta!");

  pinMode(led, OUTPUT);
  pinMode(sensor, INPUT);
  pinMode(buzzer, OUTPUT);
  Serial.begin(9600); 
}

void loop()
{
  if (errors == 3) {
    lcd.clear();
    lcd.setCursor(4, 0);
    lcd.print("Politie");
    lcd.setCursor(3, 1);
    lcd.print("apelata!!!");
    delay(5000);
  } else {
    val = digitalRead(sensor);
    
    if (val == HIGH && !citit) { 
      digitalWrite(led, HIGH);
      citit = true;
      tone(buzzer, 3000);
      delay(500);
      if (state == LOW) {
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("Pericol detectat");
        lcd.setCursor(2, 1);
        lcd.print("PIN: ");
          
        state = HIGH;
        int cursor = 7;
        
        while(1) {
          char key = keypad.getKey();
  
          if (key) {
            Serial.println(key);
        
            if(key == '*') {
              input_password = "";
            } else if(key == '#') {
              if(password == input_password) {
                noTone(buzzer);
                lcd.clear();
                lcd.setCursor(2, 0);
                lcd.print("Parola este");
                lcd.setCursor(4, 1);
                lcd.print("corecta!");
                val = LOW;
                input_password = "";
                errors = 0;
                break;
              } else {
                errors++;
                if (errors == 3) {
                  lcd.clear();
                  break;
                }
                input_password = "";
                cursor = 7;
                lcd.clear();
                lcd.setCursor(0, 0);
                lcd.print("Parola incorecta");
                lcd.setCursor(2, 1);
                lcd.print("PIN: ");
              }
            } else {
              input_password += key;
              lcd.setCursor(cursor, 1);
              lcd.print("*");
              cursor++;
            }
          }
        }
  
        val = LOW;
        delay(5000);
      }
  
      if (val == LOW && citit) {
        Serial.println("Daa");
        digitalWrite(led, LOW);
        noTone(buzzer);
        delay(500);
        if (state == HIGH) {
          lcd.clear();
          lcd.setCursor(3, 0);
          lcd.print("Sunteti in");
          lcd.setCursor(3, 1);
          lcd.print("siguranta!");
          state = LOW; 
        }
        citit = false;
      }
    }
  } 
}
